#ifdef __ASSEMBLER__
.intel_syntax

.struct 0
iDividend:	.quad	0
iDivisor:	.quad	0
iQuotient:	.quad	0
iRemainder:	.quad	0
scratch:	.quad	0
.text

.global xtUMSlashMod

xtUMSlashMod:
	push	%rax
	push	%rcx
	push	%rdx
	push	%rbx
	sub	%rax,%rax
	sub	%rcx,%rcx
	sub	%rdx,%rdx
	sub	%rbx,%rbx
.if 1
	mov	%ax,0
	mov	%bx,[%rdi+iDivisor+0]
	mov	%cx,16
	mov	%dx,0
1:	shr	%bx
	rcr	%ax
	sub	[%rdi+iDividend+0],%ax
	sbb	[%rdi+iDividend+2],%bx
	jnc	2f
	add	[%rdi+iDividend+0],%ax
	adc	[%rdi+iDividend+2],%bx
2:	rcl	%dx
	loop	1b
	not	%dx
	mov	[%rdi+iQuotient+0],%dx

	mov	%ax,[%rdi+iDividend+0]
	mov	[%rdi+iRemainder+0],%ax
.else
	mov	byte ptr [%rdi+scratch+0],16
	mov	%al,0
	mov	%bl,0
	mov	%cl,[%rdi+iDivisor+0]
	mov	%dl,[%rdi+iDivisor+1]
	mov	[%rdi+iQuotient+0],%al
	mov	[%rdi+iQuotient+1],%al
1:	shr	%dl
	rcr	%cl
	rcr	%bl
	rcr	%al
	sub	[%rdi+iDividend+0],%al
	sbb	[%rdi+iDividend+1],%bl
	sbb	[%rdi+iDividend+2],%cl
	sbb	[%rdi+iDividend+3],%dl
	jnc	2f
	add	[%rdi+iDividend+0],%al
	adc	[%rdi+iDividend+1],%bl
	adc	[%rdi+iDividend+2],%cl
	adc	[%rdi+iDividend+3],%dl
2:	rcl	byte ptr [%rdi+iQuotient+0]
	rcl	byte ptr [%rdi+iQuotient+1]
	dec	byte ptr [%rdi+scratch+0]
	jnz	1b
	not	byte ptr [%rdi+iQuotient+0]
	not	byte ptr [%rdi+iQuotient+1]

	mov	%al,[%rdi+iDividend+0]
	mov	%bl,[%rdi+iDividend+1]
	mov	[%rdi+iRemainder+0],%al
	mov	[%rdi+iRemainder+1],%bl
.endif
	pop	%rbx
	pop	%rdx
	pop	%rcx
	pop	%rax
	ret

.end
#endif /* __ASSEMBLER__ */

struct state {
	long iDividend, iDivisor, iQuotient, iRemainder;
	long scratch;
};
void xtUMSlashMod(struct state *rdi);

#include <stdio.h>
void test(long a)
{
	struct state s = { 0 };
	long b;
	for(b = 1; b <= 65535; b++) {
		s.iDividend = a;
		s.iDivisor = b;
		xtUMSlashMod(&s);
		if(a != b * s.iQuotient + s.iRemainder) { fprintf(stderr, "%ld != %ld * %ld + %ld\n", a, b, s.iQuotient, s.iRemainder); return; }
	}
}
#include <pthread.h>
pthread_t threadid[4];
pthread_mutex_t mutex;
long shared_variable;
void *thread(void *arg)
{
	for(;;) {
		pthread_mutex_lock(&mutex);
		long work_variable = shared_variable++;
		pthread_mutex_unlock(&mutex);

		if(work_variable > 65535) break;
		test(work_variable);

		int percent = work_variable * 999 / 65535;
		fprintf(stderr, "%2d.%d%%\b\b\b\b\b", percent / 10, percent % 10);
	}
	return(arg);
}
int main()
{
	shared_variable = 0;

	pthread_mutex_init(&mutex, 0);
	int a; for(a = 0; a < 4; a++) pthread_create(&threadid[a], 0, thread, 0);
	int b; for(b = 0; b < 4; b++) pthread_join(threadid[b], 0);
	pthread_mutex_destroy(&mutex);
}
