#ifdef __ASSEMBLER__
.intel_syntax

.struct 0
iMultiplier:	.quad	0
iMultiplicand:	.quad	0
iProduct:	.quad	0
scratch:	.quad	0
.text

.global xtUMStar

xtUMStar:
	push	%rax
	push	%rcx
	push	%rdx
	push	%rbx
	sub	%rax,%rax
	sub	%rcx,%rcx
	sub	%rdx,%rdx
	sub	%rbx,%rbx
.if 1
	mov	%ax,0
	mov	%bx,[%rdi+iMultiplicand+0]
	mov	%cx,16
	mov	%dx,[%rdi+iMultiplier+0]
	mov	[%rdi+iProduct+0],%ax
	mov	[%rdi+iProduct+2],%ax
1:	shr	%bx
	rcr	%ax
	shl	%dx
	jnc	2f
	add	[%rdi+iProduct+0],%ax
	adc	[%rdi+iProduct+2],%bx
2:	loop	1b
.else
	mov	byte ptr [%rdi+scratch+0],16
	mov	%al,0
	mov	%bl,0
	mov	%cl,[%rdi+iMultiplicand+0]
	mov	%dl,[%rdi+iMultiplicand+1]
	mov	[%rdi+iProduct+0],%al
	mov	[%rdi+iProduct+1],%al
	mov	[%rdi+iProduct+2],%al
	mov	[%rdi+iProduct+3],%al
1:	shr	%dl
	rcr	%cl
	rcr	%bl
	rcr	%al
	shl	byte ptr [%rdi+iMultiplier+0]
	rcl	byte ptr [%rdi+iMultiplier+1]
	jnc	2f
	add	[%rdi+iProduct+0],%al
	adc	[%rdi+iProduct+1],%bl
	adc	[%rdi+iProduct+2],%cl
	adc	[%rdi+iProduct+3],%dl
2:	dec	byte ptr [%rdi+scratch+0]
	jnz	1b
.endif
	pop	%rbx
	pop	%rdx
	pop	%rcx
	pop	%rax
	ret

.end
#endif /* __ASSEMBLER__ */

struct state {
	long iMultiplier, iMultiplicand, iProduct;
	long scratch;
};
void xtUMStar(struct state *rdi);

#include <stdio.h>
void test(long a)
{
	struct state s = { 0 };
	long b;
	for(b = 0; b <= 65535; b++) {
		s.iMultiplier = a;
		s.iMultiplicand = b;
		xtUMStar(&s);
		if(a * b != s.iProduct) { fprintf(stderr, "%ld * %ld != %ld\n", a, b, s.iProduct); return; }
	}
}
#include <pthread.h>
pthread_t threadid[4];
pthread_mutex_t mutex;
long shared_variable;
void *thread(void *arg)
{
	for(;;) {
		pthread_mutex_lock(&mutex);
		long work_variable = shared_variable++;
		pthread_mutex_unlock(&mutex);

		if(work_variable > 65535) break;
		test(work_variable);

		int percent = work_variable * 999 / 65535;
		fprintf(stderr, "%2d.%d%%\b\b\b\b\b", percent / 10, percent % 10);
	}
	return(arg);
}
int main()
{
	shared_variable = 0;

	pthread_mutex_init(&mutex, 0);
	int a; for(a = 0; a < 4; a++) pthread_create(&threadid[a], 0, thread, 0);
	int b; for(b = 0; b < 4; b++) pthread_join(threadid[b], 0);
	pthread_mutex_destroy(&mutex);
}
